## ros-one-canopen-motor-node 0.8.5-21jammy.20251023.0348

=== debian/changelog ===
ros-one-canopen-motor-node (0.8.5-21jammy.20251023.0348) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 23 Oct 2025 03:48:02 +0000

ros-one-canopen-motor-node (0.8.5-0jammy) jammy; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 22 Sep 2020 00:00:00 -0000

ros-one-canopen-motor-node (0.8.4-0jammy) jammy; urgency=high

  * moved XmlRpcSettings to socketcan_interface
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sat, 22 Aug 2020 00:00:00 -0000

ros-one-canopen-motor-node (0.8.3-0jammy) jammy; urgency=high

  * Bump CMake version to avoid CMP0048 warning
    Signed-off-by: ahcorde <mailto:ahcorde@gmail.com>
  * Contributors: ahcorde

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 07 May 2020 00:00:00 -0000

ros-one-canopen-motor-node (0.8.2-0jammy) jammy; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 04 Nov 2019 00:00:00 -0000

ros-one-canopen-motor-node (0.8.1-0jammy) jammy; urgency=high

  * Set C++ standard to c++14
  * inherit LimitsHandle from LimitsHandleBase
  * Contributors: Harsh Deshpande, Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sun, 14 Jul 2019 00:00:00 -0000

ros-one-canopen-motor-node (0.8.0-0jammy) jammy; urgency=high

  * migrated to std::function and std::bind
  * use std::isnan
  * migrated to std::atomic
  * migrated to std::unordered_map and std::unordered_set
  * migrated to std pointers
  * removed deprecated types
  * introduced HandleLayerSharedPtr
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Wed, 11 Jul 2018 00:00:00 -0000

ros-one-canopen-motor-node (0.7.8-0jammy) jammy; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 04 May 2018 00:00:00 -0000

ros-one-canopen-motor-node (0.7.7-0jammy) jammy; urgency=high

  * added types for all function objects
  * added types for all shared_ptrs
  * error if muparser is not available
  * address catkin_lint errors/warnings
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 04 May 2018 00:00:00 -0000

ros-one-canopen-motor-node (0.7.6-0jammy) jammy; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Wed, 30 Aug 2017 00:00:00 -0000

ros-one-canopen-motor-node (0.7.5-0jammy) jammy; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 29 May 2017 00:00:00 -0000

ros-one-canopen-motor-node (0.7.4-0jammy) jammy; urgency=high

  * use portable boost::math::isnan
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 25 Apr 2017 00:00:00 -0000

ros-one-canopen-motor-node (0.7.3-0jammy) jammy; urgency=high

  * use urdf::JointConstSharedPtr
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 25 Apr 2017 00:00:00 -0000

ros-one-canopen-motor-node (0.7.2-0jammy) jammy; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 28 Mar 2017 00:00:00 -0000

ros-one-canopen-motor-node (0.7.1-0jammy) jammy; urgency=high

  * Decouble RobotLayer by introducing HandleLayerBase
  * Split layers into different headers and compile units
  * do not call handleReadread in HandleLayer::handleRecover
    this prevents a race condition, it is not needed anyway.
  * protect ObjectVariables with mutex
  * added test for norm function
  * fix for joint limit handling
  * introduced per-controller enforce_limits parameter
  * implemented per-joint limits handling
  * check if hardware interface matches mode
  * implemented mixed-mode switching (#197 <https://github.com/ipa-mdl/ros_canopen/issues/197>)
  * introduced joint reference for *res_it
  * Contributors: Mathias Lüdtke, Michael Stoll

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 20 Mar 2017 00:00:00 -0000

ros-one-canopen-motor-node (0.7.0-0jammy) jammy; urgency=high

  * multi-mode controllers are not supported (#197 <https://github.com/ros-industrial/ros_canopen/issues/197>)
  * Adaption to https://github.com/ros-controls/ros_control/commit/afaf9403d1daf6e7f0a93e4a06aa9695e2883632
  * Contributors: Mathias Lüdtke, Michael Stoll

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 13 Dec 2016 00:00:00 -0000

ros-one-canopen-motor-node (0.6.5-0jammy) jammy; urgency=high

  * protect MotorChain setup with RosChain lock
  * Merge pull request #153 <https://github.com/ipa-mdl/ros_canopen/issues/153> from ipa-mdl/deprecated-canswitch
    deprecated canSwitch
  * fix for issue #171 <https://github.com/ipa-mdl/ros_canopen/issues/171>
  * Merge pull request #168 <https://github.com/ipa-mdl/ros_canopen/issues/168> from ipa-mdl/state-filters
    added filter chain for state values
  * do not start driver if filter config fails
  * added filter chain for state values
  * log control period settings
  * use update_period_ for controll unless use_realtime_period is set true
  * better initialize last_time_
  * removed canSwitch implementation, added compile-time check for prepareSwitch
  * exit code for generic error should be 1, not -1
  * styled and sorted CMakeLists.txt
    * removed boilerplate comments
    * indention
    * reviewed exported dependencies
  * styled and sorted package.xml
  * update package URLs
  * foward commands ony if enabled in doSwitch
  * moved switch implemenation to non-RT prepareSwitch
  * migrated to non-const prepareSwitch
  * Splitted control_node.cpp into control_node.cpp, robot_layer.cpp and robot_layer.h
  * renamed chain_ros.h to ros_chain.h, fixes #126 <https://github.com/ipa-mdl/ros_canopen/issues/126>
  * added strictness to service call, extend error message for doSwitch fails
  * stop controllers that failed switching via service call
  * stop all cotnroller joints if one failed to switch
  * check for ready state before controller/mode switching


## ros-one-canopen-motor-node 0.8.5-21jammy.20260221.0025

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(canopen_motor_node)

find_package(catkin REQUIRED
  COMPONENTS
    canopen_402
    canopen_chain_node
    canopen_master
    controller_manager
    controller_manager_msgs
    filters
    hardware_interface
    joint_limits_interface
    roscpp
    urdf
)

find_package(Boost REQUIRED
  COMPONENTS
    thread
)

find_package(PkgConfig)
pkg_check_modules(PC_MUPARSER QUIET muparser)
set(MUPARSER_DEFINITIONS ${PC_MUPARSER_CFLAGS_OTHER})

find_path(MUPARSER_INCLUDE_DIR muParser.h
          HINTS ${PC_MUPARSER_INCLUDEDIR} ${PC_MUPARSER_INCLUDE_DIRS}
)

find_library(MUPARSER_LIBRARY NAMES muparser libmurser
             HINTS ${PC_MUPARSER_LIBDIR} ${PC_MUPARSER_LIBRARY_DIRS} )

include(FindPackageHandleStandardArgs)
# handle the QUIETLY and REQUIRED arguments and set MUPARSER_FOUND to TRUE
# if all listed variables are TRUE
find_package_handle_standard_args(MUPARSER  DEFAULT_MSG
                                  MUPARSER_LIBRARY MUPARSER_INCLUDE_DIR)
mark_as_advanced(MUPARSER_INCLUDE_DIR MUPARSER_LIBRARY )

if(NOT ${MUPARSER_FOUND})
  message(FATAL_ERROR "muparser library not found")  
endif()

set(MUPARSER_LIBRARIES ${MUPARSER_LIBRARY} )
set(MUPARSER_INCLUDE_DIRS ${MUPARSER_INCLUDE_DIR} )

catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES
    canopen_motor
  CATKIN_DEPENDS
    canopen_402
    canopen_chain_node
    canopen_master
    controller_manager
    hardware_interface
    joint_limits_interface
    roscpp
    urdf
  DEPENDS
    Boost
    MUPARSER
)

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${MUPARSER_INCLUDE_DIRS}
)

# canopen_motor
add_library(canopen_motor
  src/controller_manager_layer.cpp
  src/handle_layer.cpp
  src/motor_chain.cpp
  src/robot_layer.cpp
)
target_link_libraries(canopen_motor
  ${catkin_LIBRARIES}
  ${MUPARSER_LIBRARIES}
)
add_dependencies(canopen_motor
  ${catkin_EXPORTED_TARGETS}
)

# canopen_motor_node
add_executable(${PROJECT_NAME}
  src/canopen_motor_chain_node.cpp
)
target_link_libraries(${PROJECT_NAME}
  canopen_motor
  ${catkin_LIBRARIES}
)
add_dependencies(${PROJECT_NAME}
  ${catkin_EXPORTED_TARGETS}
)

install(
  TARGETS
    canopen_motor
    ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)

if(CATKIN_ENABLE_TESTING)
  catkin_add_gtest(${PROJECT_NAME}-test_muparser
    test/test_muparser.cpp
  )
  target_link_libraries(${PROJECT_NAME}-test_muparser
    canopen_motor
    ${catkin_LIBRARIES}
    ${MUPARSER_LIBRARIES}
  )
endif()

=== debian/changelog ===
ros-one-canopen-motor-node (0.8.5-21jammy.20260221.0025) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sat, 21 Feb 2026 00:25:58 +0000

=== debian/control ===
Source: ros-one-canopen-motor-node
Section: misc
Priority: optional
Maintainer: Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>
Build-Depends: debhelper (>= 9.0.0), libboost-dev, libboost-thread-dev, libmuparser-dev, ros-one-canopen-402, ros-one-canopen-chain-node, ros-one-canopen-master, ros-one-catkin, ros-one-controller-manager, ros-one-controller-manager-msgs, ros-one-filters, ros-one-hardware-interface, ros-one-joint-limits-interface, ros-one-roscpp, ros-one-urdf
Homepage: http://wiki.ros.org/canopen_motor_node
Standards-Version: 3.9.2

Package: ros-one-canopen-motor-node
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-dev, libboost-thread-dev, libmuparser-dev, ros-one-canopen-402, ros-one-canopen-chain-node, ros-one-canopen-master, ros-one-controller-manager, ros-one-controller-manager-msgs, ros-one-filters, ros-one-hardware-interface, ros-one-joint-limits-interface, ros-one-roscpp, ros-one-urdf
Description: canopen_chain_node specialization for handling of canopen_402 motor devices.
 It facilitates interface abstraction with ros_control.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-canopen-motor-node//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-canopen-motor-node 0.8.5-21noble.20260221.0054

=== debian/changelog ===
ros-one-canopen-motor-node (0.8.5-21noble.20260221.0054) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sat, 21 Feb 2026 00:54:34 +0000

ros-one-canopen-motor-node (0.8.5-0noble) noble; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 22 Sep 2020 00:00:00 -0000

ros-one-canopen-motor-node (0.8.4-0noble) noble; urgency=high

  * moved XmlRpcSettings to socketcan_interface
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sat, 22 Aug 2020 00:00:00 -0000

ros-one-canopen-motor-node (0.8.3-0noble) noble; urgency=high

  * Bump CMake version to avoid CMP0048 warning
    Signed-off-by: ahcorde <mailto:ahcorde@gmail.com>
  * Contributors: ahcorde

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 07 May 2020 00:00:00 -0000

ros-one-canopen-motor-node (0.8.2-0noble) noble; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 04 Nov 2019 00:00:00 -0000

ros-one-canopen-motor-node (0.8.1-0noble) noble; urgency=high

  * Set C++ standard to c++14
  * inherit LimitsHandle from LimitsHandleBase
  * Contributors: Harsh Deshpande, Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sun, 14 Jul 2019 00:00:00 -0000

ros-one-canopen-motor-node (0.8.0-0noble) noble; urgency=high

  * migrated to std::function and std::bind
  * use std::isnan
  * migrated to std::atomic
  * migrated to std::unordered_map and std::unordered_set
  * migrated to std pointers
  * removed deprecated types
  * introduced HandleLayerSharedPtr
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Wed, 11 Jul 2018 00:00:00 -0000

ros-one-canopen-motor-node (0.7.8-0noble) noble; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 04 May 2018 00:00:00 -0000

ros-one-canopen-motor-node (0.7.7-0noble) noble; urgency=high

  * added types for all function objects
  * added types for all shared_ptrs
  * error if muparser is not available
  * address catkin_lint errors/warnings
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 04 May 2018 00:00:00 -0000

ros-one-canopen-motor-node (0.7.6-0noble) noble; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Wed, 30 Aug 2017 00:00:00 -0000

ros-one-canopen-motor-node (0.7.5-0noble) noble; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 29 May 2017 00:00:00 -0000

ros-one-canopen-motor-node (0.7.4-0noble) noble; urgency=high

  * use portable boost::math::isnan
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 25 Apr 2017 00:00:00 -0000

ros-one-canopen-motor-node (0.7.3-0noble) noble; urgency=high

  * use urdf::JointConstSharedPtr
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 25 Apr 2017 00:00:00 -0000

ros-one-canopen-motor-node (0.7.2-0noble) noble; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 28 Mar 2017 00:00:00 -0000

ros-one-canopen-motor-node (0.7.1-0noble) noble; urgency=high

  * Decouble RobotLayer by introducing HandleLayerBase
  * Split layers into different headers and compile units
  * do not call handleReadread in HandleLayer::handleRecover
    this prevents a race condition, it is not needed anyway.
  * protect ObjectVariables with mutex
  * added test for norm function
  * fix for joint limit handling
  * introduced per-controller enforce_limits parameter
  * implemented per-joint limits handling
  * check if hardware interface matches mode
  * implemented mixed-mode switching (#197 <https://github.com/ipa-mdl/ros_canopen/issues/197>)
  * introduced joint reference for *res_it
  * Contributors: Mathias Lüdtke, Michael Stoll

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 20 Mar 2017 00:00:00 -0000

ros-one-canopen-motor-node (0.7.0-0noble) noble; urgency=high

  * multi-mode controllers are not supported (#197 <https://github.com/ros-industrial/ros_canopen/issues/197>)
  * Adaption to https://github.com/ros-controls/ros_control/commit/afaf9403d1daf6e7f0a93e4a06aa9695e2883632
  * Contributors: Mathias Lüdtke, Michael Stoll

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 13 Dec 2016 00:00:00 -0000

ros-one-canopen-motor-node (0.6.5-0noble) noble; urgency=high

  * protect MotorChain setup with RosChain lock
  * Merge pull request #153 <https://github.com/ipa-mdl/ros_canopen/issues/153> from ipa-mdl/deprecated-canswitch
    deprecated canSwitch
  * fix for issue #171 <https://github.com/ipa-mdl/ros_canopen/issues/171>
  * Merge pull request #168 <https://github.com/ipa-mdl/ros_canopen/issues/168> from ipa-mdl/state-filters
    added filter chain for state values
  * do not start driver if filter config fails
  * added filter chain for state values
  * log control period settings
  * use update_period_ for controll unless use_realtime_period is set true
  * better initialize last_time_
  * removed canSwitch implementation, added compile-time check for prepareSwitch
  * exit code for generic error should be 1, not -1
  * styled and sorted CMakeLists.txt
    * removed boilerplate comments
    * indention
    * reviewed exported dependencies
  * styled and sorted package.xml
  * update package URLs
  * foward commands ony if enabled in doSwitch
  * moved switch implemenation to non-RT prepareSwitch
  * migrated to non-const prepareSwitch
  * Splitted control_node.cpp into control_node.cpp, robot_layer.cpp and robot_layer.h
  * renamed chain_ros.h to ros_chain.h, fixes #126 <https://github.com/ipa-mdl/ros_canopen/issues/126>
  * added strictness to service call, extend error message for doSwitch fails
  * stop controllers that failed switching via service call
  * stop all cotnroller joints if one failed to switch
  * check for ready state before controller/mode switching
